vigra - GridGraph< N, DirectedTag >::ArcMap< T > Class Template Reference

[ VIGRA Homepage | Function Index | Class Index | Namespaces | File List | Main Page ]

| GridGraph< N, DirectedTag >::ArcMap< T > Class Template Reference |

Type of an arc property map that maps arc descriptor objects onto property values of type `T` (API: LEMON). More...

`#include <vigra/multi_gridgraph.hxx>`

Inheritance diagram for GridGraph< N, DirectedTag >::ArcMap< T >:

## Public Member Functions
| ArcMap (GridGraph const &g)
| Construct property map for the given graph g (preallocates a zero-initialized entry for each arc of the graph).
| ArcMap (GridGraph const &g, T const &t)
| Construct property map for the given graph g (preallocates an entry with initial value t for each arc of the graph).
| ArcMap (difference_type const &shape)
| Construct property map for the given shape (preallocates a zero-initialized entry for each arc of a grid graph with this shape).
| ArcMap (difference_type const &shape, T const &t)
| Construct property map for the given shape (preallocates an entry with initial value t for each arc of a grid graph with this shape).
Value & | operator[] (Key const &key)
| Read/write access to the value associated with arc descriptor key.
Value const & | operator[] (Key const &key) const
| Read-only access to the value associated with arc descriptor key.
void | set (Key const &k, Value const &v)
| Set the property of arc desctiptor key to value v.
Public Member Functions inherited from MultiArray< N+1, Multiband< T > >
allocator_type const & | allocator () const
MultiArray & | init (const U &init)
| MultiArray ()
| MultiArray (allocator_type const &alloc)
| MultiArray (difference_type_1 length, allocator_type const &alloc=allocator_type())
| MultiArray (difference_type_1 width, difference_type_1 height, allocator_type const &alloc=allocator_type())
| MultiArray (const difference_type &shape, allocator_type const &alloc=allocator_type())
| MultiArray (const difference_type &shape, const_reference init, allocator_type const &alloc=allocator_type())
| MultiArray (const difference_type &shape, MultiArrayInitializationTag init, allocator_type const &alloc=allocator_type())
| MultiArray (const difference_type &shape, const_pointer init, allocator_type const &alloc=allocator_type())
| MultiArray (const MultiArray &rhs)
| MultiArray (multi_math::MultiMathOperand< Expression > const &rhs, allocator_type const &alloc=allocator_type())
| MultiArray (const MultiArrayView< N, U, StrideTag > &rhs, allocator_type const &alloc=allocator_type())
MultiArray & | operator*= (const MultiArrayView< N, U, StrideTag > &rhs)
MultiArray & | operator*= (const Multiband< T > &rhs)
MultiArray & | operator*= (multi_math::MultiMathOperand< Expression > const &rhs)
MultiArray & | operator+= (const MultiArrayView< N, U, StrideTag > &rhs)
MultiArray & | operator+= (const Multiband< T > &rhs)
MultiArray & | operator+= (multi_math::MultiMathOperand< Expression > const &rhs)
MultiArray & | operator-= (const MultiArrayView< N, U, StrideTag > &rhs)
MultiArray & | operator-= (const Multiband< T > &rhs)
MultiArray & | operator-= (multi_math::MultiMathOperand< Expression > const &rhs)
MultiArray & | operator/= (const MultiArrayView< N, U, StrideTag > &rhs)
MultiArray & | operator/= (const Multiband< T > &rhs)
MultiArray & | operator/= (multi_math::MultiMathOperand< Expression > const &rhs)
MultiArray & | operator= (const MultiArray &rhs)
MultiArray & | operator= (const MultiArrayView< N, U, StrideTag > &rhs)
MultiArray & | operator= (value_type const &v)
MultiArray & | operator= (multi_math::MultiMathOperand< Expression > const &rhs)
void | reshape (const difference_type &shape)
void | reshape (const difference_type &shape, const_reference init)
void | swap (MultiArray &other)
| ~MultiArray ()
Public Member Functions inherited from MultiArrayView< N, T, StrideTag >
bool | all () const
bool | any () const
iterator | begin ()
const_iterator | begin () const
template<unsigned int M>
MultiArrayView< N-1, T, typename vigra::detail::MaybeStrided < StrideTag, M >::type > | bind (difference_type_1 d) const
MultiArrayView< N-1, T, StridedArrayTag > | bindAt (difference_type_1 m, difference_type_1 d) const
MultiArrayView< N, typename ExpandElementResult< T >::type, StridedArrayTag > | bindElementChannel (difference_type_1 i) const
template<int M, class Index >
MultiArrayView< N-M, T, StridedArrayTag > | bindInner (const TinyVector< Index, M > &d) const
MultiArrayView< N-1, T, StridedArrayTag > | bindInner (difference_type_1 d) const
template<int M, class Index >
MultiArrayView< N-M, T, StrideTag > | bindOuter (const TinyVector< Index, M > &d) const
MultiArrayView< N-1, T, StrideTag > | bindOuter (difference_type_1 d) const
difference_type_1 | coordinateToScanOrderIndex (const difference_type &d) const
void | copy (const MultiArrayView &rhs)
template<class U , class CN >
void | copy (const MultiArrayView< N, U, CN > &rhs)
pointer | data () const
MultiArrayView< 1, T, StridedArrayTag > | diagonal () const
difference_type_1 | elementCount () const
iterator | end ()
const_iterator | end () const
MultiArrayView< N+1, typename ExpandElementResult< T >::type, StridedArrayTag > | expandElements (difference_type_1 d) const
bool | hasData () const
difference_type_1 | height () const
template<class U >
MultiArrayView & | init (const U &init)
MultiArrayView< N+1, T, StrideTag > | insertSingletonDimension (difference_type_1 i) const
bool | isInside (difference_type const &p) const
bool | isOutside (difference_type const &p) const
bool | isUnstrided (unsigned int dimension=N-1) const
template<class U >
void | meanVariance (U *mean, U *variance) const
void | minmax (T *minimum, T *maximum) const
| MultiArrayView ()
template<class Stride >
| MultiArrayView (const MultiArrayView< N, T, Stride > &other)
| MultiArrayView (const difference_type &shape, const_pointer ptr)
| MultiArrayView (const difference_type &shape, const difference_type &stride, const_pointer ptr)
template<class ALLOC >
| MultiArrayView (BasicImage< T, ALLOC > const &image)
MultiArrayView< N, Multiband < value_type >, StrideTag > | multiband () const
NormTraits< MultiArrayView > ::NormType | norm (int type=2, bool useSquaredNorm=true) const
| operator MultiArrayView< N, T, StridedArrayTag > () const
template<class U , class C1 >
bool | operator!= (MultiArrayView< N, U, C1 > const &rhs) const
reference | operator() (difference_type_1 x)
reference | operator() (difference_type_1 x, difference_type_1 y)
reference | operator() (difference_type_1 x, difference_type_1 y, difference_type_1 z)
reference | operator() (difference_type_1 x, difference_type_1 y, difference_type_1 z, difference_type_1 u)
reference | operator() (difference_type_1 x, difference_type_1 y, difference_type_1 z, difference_type_1 u, difference_type_1 v)
const_reference | operator() (difference_type_1 x) const
const_reference | operator() (difference_type_1 x, difference_type_1 y) const
const_reference | operator() (difference_type_1 x, difference_type_1 y, difference_type_1 z) const
const_reference | operator() (difference_type_1 x, difference_type_1 y, difference_type_1 z, difference_type_1 u) const
const_reference | operator() (difference_type_1 x, difference_type_1 y, difference_type_1 z, difference_type_1 u, difference_type_1 v) const
template<class U , class C1 >
MultiArrayView & | operator*= (MultiArrayView< N, U, C1 > const &rhs)
MultiArrayView & | operator*= (T const &rhs)
template<class Expression >
MultiArrayView & | operator*= (multi_math::MultiMathOperand< Expression > const &rhs)
template<class U , class C1 >
MultiArrayView & | operator+= (MultiArrayView< N, U, C1 > const &rhs)
MultiArrayView & | operator+= (T const &rhs)
template<class Expression >
MultiArrayView & | operator+= (multi_math::MultiMathOperand< Expression > const &rhs)
template<class U , class C1 >
MultiArrayView & | operator-= (MultiArrayView< N, U, C1 > const &rhs)
MultiArrayView & | operator-= (T const &rhs)
template<class Expression >
MultiArrayView & | operator-= (multi_math::MultiMathOperand< Expression > const &rhs)
template<class U , class C1 >
MultiArrayView & | operator/= (MultiArrayView< N, U, C1 > const &rhs)
MultiArrayView & | operator/= (T const &rhs)
template<class Expression >
MultiArrayView & | operator/= (multi_math::MultiMathOperand< Expression > const &rhs)
MultiArrayView & | operator= (MultiArrayView const &rhs)
template<class U , class C1 >
MultiArrayView & | operator= (MultiArrayView< N, U, C1 > const &rhs)
MultiArrayView & | operator= (value_type const &v)
template<class Expression >
MultiArrayView & | operator= (multi_math::MultiMathOperand< Expression > const &rhs)
template<class U , class C1 >
bool | operator== (MultiArrayView< N, U, C1 > const &rhs) const
reference | operator[] (const difference_type &d)
const_reference | operator[] (const difference_type &d) const
template<int M>
MultiArrayView< N-M, T, StridedArrayTag > | operator[] (const TinyVector< MultiArrayIndex, M > &d) const
reference | operator[] (difference_type_1 d)
const_reference | operator[] (difference_type_1 d) const
MultiArrayView< N, T, StridedArrayTag > | permuteStridesAscending () const
MultiArrayView< N, T, StridedArrayTag > | permuteStridesDescending () const
template<class U >
U | product () const
void | reset ()
difference_type | scanOrderIndexToCoordinate (difference_type_1 d) const
const difference_type & | shape () const
difference_type_1 | shape (difference_type_1 n) const
difference_type_1 | size () const
difference_type_1 | size (difference_type_1 n) const
NormTraits< MultiArrayView > ::SquaredNormType | squaredNorm () const
const difference_type & | stride () const
difference_type_1 | stride (int n) const
MultiArrayView< N, T, StridedArrayTag > | stridearray (const difference_type &s) const
difference_type | strideOrdering () const
MultiArrayView | subarray (difference_type p, difference_type q) const
template<class U >
U | sum () const
template<class U , class S >
void | sum (MultiArrayView< N, U, S > sums) const
void | swap (MultiArrayView &other)
void | swapData (MultiArrayView rhs)
template<class T2 , class C2 >
void | swapData (MultiArrayView< N, T2, C2 > rhs)
MultiArrayView< N, T, StridedArrayTag > | transpose () const
MultiArrayView< N, T, StridedArrayTag > | transpose (const difference_type &permutation) const
traverser | traverser_begin ()
const_traverser | traverser_begin () const
traverser | traverser_end ()
const_traverser | traverser_end () const
difference_type_1 | width () const

## Additional Inherited Members
Public Types inherited from MultiArray< N+1, Multiband< T > >
typedef A | allocator_type
typedef view_type::const_iterator | const_iterator
typedef view_type::const_pointer | const_pointer
typedef view_type::const_reference | const_reference
typedef view_type::const_traverser | const_traverser
typedef view_type::difference_type | difference_type
typedef view_type::difference_type_1 | difference_type_1
typedef view_type::iterator | iterator
typedef MultiArray< N, Multiband< T >, A > | matrix_type
typedef view_type::pointer | pointer
typedef view_type::reference | reference
typedef view_type::size_type | size_type
typedef view_type::traverser | traverser
typedef view_type::value_type | value_type
typedef MultiArrayView< N, typename vigra::detail::ResolveMultiband < Multiband< T > >::type, typename vigra::detail::ResolveMultiband < Multiband< T > >::Stride > | view_type
Public Types inherited from MultiArrayView< N, T, StrideTag >
enum | ActualDimension
typedef StridedScanOrderIterator < actual_dimension, T, T const &, T const * > | const_iterator
typedef const value_type * | const_pointer
typedef const value_type & | const_reference
typedef vigra::detail::MultiIteratorChooser < StrideTag >::template Traverser< actual_dimension, T, T const &, T const * >::type | const_traverser
typedef MultiArrayShape < actual_dimension >::type | difference_type
typedef MultiArrayIndex | difference_type_1
typedef StridedScanOrderIterator < actual_dimension, T, T &, T * > | iterator
typedef difference_type | key_type
typedef MultiArray< N, T > | matrix_type
typedef value_type * | pointer
typedef value_type & | reference
typedef difference_type | size_type
typedef vigra::detail::MultiIteratorChooser < StrideTag >::template Traverser< actual_dimension, T, T &, T * >::type | traverser
typedef T | value_type
typedef MultiArrayView< N, T, StrideTag > | view_type
Static Public Member Functions inherited from MultiArrayView< N, T, StrideTag >
static difference_type | strideOrdering (difference_type strides)
Protected Member Functions inherited from MultiArray< N+1, Multiband< T > >
void | allocate (pointer &ptr, difference_type_1 s, const_reference init)
void | allocate (pointer &ptr, difference_type_1 s, U const *init)
void | allocate (pointer &ptr, MultiArrayView< N, U, StrideTag > const &init)
void | deallocate (pointer &ptr, difference_type_1 s)
Protected Attributes inherited from MultiArray< N+1, Multiband< T > >
allocator_type | m_alloc
Protected Attributes inherited from MultiArrayView< N, T, StrideTag >
pointer | m_ptr
difference_type | m_shape
difference_type | m_stride

## Detailed Description

### template<unsigned int N, class DirectedTag>
template<class T>
class vigra::GridGraph< N, DirectedTag >::ArcMap< T >

Type of an arc property map that maps arc descriptor objects onto property values of type `T` (API: LEMON).

The documentation for this class was generated from the following file:

- vigra/multi_gridgraph.hxx

© Ullrich Köthe (ullrich.koethe@iwr.uni-heidelberg.de) Heidelberg Collaboratory for Image Processing, University of Heidelberg, Germany | html generated using doxygen and Python vigra 1.11.0 (Fri May 19 2017)